#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/malloc.h>
#include <linux/mm.h>
#include <linux/string.h>
#include <net/ip_masq.h>

#define STICKY_ON_IP 1
#define STICKY_ON_IP_PORT 2
#define NON_STICKY 3


/* client domain vs. ipaddress
   wetterhorn     80c6a2d9,
   redcloud       80c6a242,
   cs             80c6a244,
   shavano        80c6a240,
   crestone       80c6a23d,
   sanluis        80c6a23e,
blanca         80c6a23c,
*/

struct ip_vs_cb_rule_field
{
  char  name[128];
  __u16 pos;
  char  value[256];
}

struct ip_vs_cb_rule_field rule_fields [] =
{
  {"url", 1, ""},
  {"purchase.totalAmount", 1, ""},
  {"purchase.item.subTotal", 1, ""}
};

int num_rule_fields = sizeof(rule_fields) / sizeof(struct ip_vs_cb_rule_field);
/*
char *xml_tag_list[2]=
{
	"purchase.totalAmount.",
	"purchase.item.subTotal."
};
 
int tag_number=2;
static char url[256];
static char xml_tag_value[50][256];
static int number=0;
extern int atoi(const char *s);
*/

extern int route_to(char * name, int flag);

__u32 rule_configure( __u32 saddr, __u32 daddr, __u16 sport, __u16 dport, __u8 protocol)
{
R4:	if(atoi(rule_fields[1].value) > 50000)
        {
          return route_to("ace", NON_STICKY);
	}

R5:	if((atoi(rule_fields[1].value) > 0) &&
           (atoi(rule_fields[1].value) <  50000)) &&
        {
          return route_to("frodo", NON_STICKY);
	}

R6:	if(strstr(rule_fields[0].value, "cs522")!=NULL)
        {
          IP_RULE_MSG("serevr=ace\n");
          return route_to("ace", NON_STICKY);
	}

R7:	if(strstr(rule_fields[0].value, "lcs1")!=NULL)
        {
          IP_RULE_MSG("serevr=ace\n");
          return route_to("ace", NON_STICKY);
	}

R8:	if(strstr(rule_fields[0].value, "lcs2")!=NULL)
        {
          IP_RULE_MSG("serevr=frodo\n");
          return route_to("frodo", NON_STICKY);
	}

  return route_to("default", NON_STICKY);
}
