/*
 * IPVS:        Round-Robin Scheduling module
 *
 * Version:     $Id: ip_vs_rr.c,v 1.5 1999/10/06 10:04:46 wensong Exp $
 *
 * Authors:     Wensong Zhang <wensong@iinchina.net>
 *              Peter Kese <peter.kese@ijs.si>
 *
 *              This program is free software; you can redistribute it and/or
 *              modify it under the terms of the GNU General Public License
 *              as published by the Free Software Foundation; either version
 *              2 of the License, or (at your option) any later version.
 *
 * Fixes/Changes:
 *     Wensong Zhang            :     changed the ip_vs_rr_schedule to return dest
 *     Julian Anastasov         :     fixed the NULL pointer access bug in debugging
 *     Wensong Zhang            :     changed some comestics things for debugging
 *     Wensong Zhang            :     changed for the d-linked destination list
 *     Wensong Zhang            :     added the ip_vs_rr_update_svc
 *     Wensong Zhang            :     added any dest with weight=0 is quiesced 
 *
 */

#include <linux/config.h>
#include <linux/module.h>
#ifdef CONFIG_KMOD
#include <linux/kmod.h>
#endif
#include <linux/string.h>
#include <linux/types.h>
#include <linux/kernel.h>
#include <linux/errno.h>
#include <net/ip_masq.h>
#ifdef CONFIG_IP_MASQUERADE_MOD
#include <net/ip_masq_mod.h>
#endif
#include <linux/sysctl.h>
#include <linux/ip_fw.h>
#include <net/ip_vs.h>
#include <net/ip_cs.h>



/*static char url[256];*/
/*static char req_data[1000];*/

char * xml_tag[50];
int tag_num;
char * xmlresult[50];
char *urlresult;
char *req_data;

int rule_configure( char *url,char *xmlresult[])
{
	int i;
	for(i=0;i<tag_num;i++){

	printk("######## IN CONFIGYRExmlresult[%d]=%s\n",i,xmlresult[i]);
	}

	printk("#######url=%s\n",url);
	if (url==NULL)
		return 0;
	if(strstr(url,"guest")!=NULL)
	{
printk("server=2\n");
		return 2;
	}

	else
		return 1;

/*	if(strstr(url,"gif")!=NULL)
 	{

		return 2;
       }

	if(strstr(url,"index.html")!=NULL)
	{
		return 3;
	}
	printk("server=0\n");
	return 0;*/

}	



char * url_extract(char * req_data)
{
	static char url[256];
	char *tail;
	int size;
	tail=strstr(req_data,"HTTP");
	
printk("######data in url_extract\n");
printk("######REQ_DATA=%s\n",req_data);
printk("######TAIL=%s\n",tail);
	if((req_data!=NULL)&&(tail!=NULL))
	{
		size=tail-req_data;
printk("#########size=%d\n",size);
	memset(url,0,size);

	memcpy(url,req_data,size);
		/*strncmp(url,req_data,size);*/
		printk("########url=%s  len=%d\n",url,strlen(url));
printk("\n");
		return url;
	}
	printk("#######url=NULL\n");
	return NULL;

}

char * xmlextract(char *xmlptr, char *tag)                                     
{
	char *tag_value;
	int i=0;
	int len;
	int node_num;
	char  node[20][50];
	char *start, *end;
	char  string1[20],string2[20],string3[20];
	
	char sub_string[1000];
	char node_value[1000];

	string1[0]='\0';

		strcat(string1,"<");
		string2[0]='\0';
		strcat(string2,">");
		string3[0]='\0';
		strcat(string3,"</");

		start=tag;
		
		do {
			end=strstr(start,".");
			if((end!=NULL)&&(start!=NULL)){
				len=end-start;
				
				memset(node[i],0,len+1);
				strncpy(node[i],start,len);

printk("##########node[%d]=%s len=%d node_value=\n",i,node[i],len);
				}
			else
				break;

			start=end+1;
			i++;
printk("###########i=%d\n",i);		
		}while(start!=NULL);

		node_num=i;


printk("#############node_num=%d\n",node_num);
	memset(sub_string,0,strlen(xmlptr)+1);
	strncpy(sub_string,xmlptr,strlen(xmlptr));

	for(i=0;i<node_num;i++)
	{
		strcat(string1,node[i]);
printk("###########start1=%s\n",string1);
		strcat(string1,string2);
printk("###########dtring1=%s\n",string1);
		strcat(string3,node[i]);
		strcat(string3,string2);
printk("###########string=%s\n",string3);
		start=strstr(sub_string,string1);
printk("###########start=%s\n",start);

		end=strstr(sub_string,string3);
printk("###########end=%s\n",end);
		if((start!=NULL)&&(end!=NULL)){
			
			len=end-start;
			node_value[0]='\0';
		/*	memset(sub_string,0,len+1);*/
			strncat(node_value,start+strlen(string3)-1,len-strlen(string3)+1);
printk("###########sub_value=%s\n",node_value);
			string1[0]='\0';

			strcat(string1,"<");
			string2[0]='\0';
			strcat(string2,">");
			string3[0]='\0';
			strcat(string3,"</");
			sub_string[0]='\0';
			strcat(sub_string,node_value);
		}
		else{
			sub_string[0]='\0';
			break;
			}
			
	}
	
	if(sub_string!=NULL){
		
		tag_value=kmalloc(strlen(sub_string)+1,GFP_KERNEL);
		memset(tag_value,0,strlen(sub_string)+1);
		memcpy(tag_value,sub_string,strlen(sub_string)+1);
		return 	tag_value;
	}
	
	else 
		return NULL;

	
}



int module_rule_matching(struct sk_buff *skb)
{
	
	struct iphdr *iph=skb->nh.iph;
	int i;
	int data_len;
	unsigned char *payload;
	
	char *xmlPtr="<?xml version=\"1.0\" encoding=\"utf-8\" standalone=\"yes\"?><!--======= The Wrox Press Book Catalog Application =======-->
<Book><Title>Professional XML</Title><Author>Mark Birbeck, Steven Livingstone, Didier Martin, Stephen Mohr, Nikola Ozu, et at.</Author>
<Publisher>Wrox Press, Ltd.</Publisher><PubDate>November 1999</PubDate><Abstract>XML 0-500kmh in 3 seconds</Abstract>
<Pages>750</Pages><ISBN>1-861003-11-0</ISBN><RecSubjCategories><Category>Internet</Category><Category>Web Publishing</Category>
<Category>XML</Category></RecSubjCategories></Book>";
	
	
	
	
	
	printk("##############This is a matching module function \n");

	payload=skb->data+iph->ihl*4+skb->h.th->doff*4;
	data_len=skb->len-(iph->ihl*4+skb->h.th->doff*4);

	if(data_len<0)
		return 0;
	req_data=kmalloc(data_len+1,GFP_KERNEL);
	memset(req_data,0,data_len+1);

	memcpy(req_data,payload,data_len);

	urlresult=url_extract(req_data);


	for(i=0;i<tag_num;i++)

	{
		printk("#####xml_tag[%d]=%s\n",i,xml_tag[i]);	
		xmlresult[i]=xmlextract(xmlPtr,xml_tag[i]);
		printk("#############xmlresult=%s\n",xmlresult[i]);
	}  
	
	for(i=0;i<tag_num;i++){

	printk("########xmlresult[%d]=%s\n",i,xmlresult[i]);
	}

		
		return rule_configure(urlresult,xmlresult);


}




void register_rule_matching()
{
	int i=0;
	do {
		xml_tag[i]=get_xml_tag(i);

		printk("#####xml_tag[%d]=%s\n",i,xml_tag[i]);	
		
		i++;
	} while(xml_tag[i-1]!=NULL);

	printk("#####tag_num=%d\n",i-1);

	tag_num=i-1;

	
	printk("#######returned=%d\n",i);

	rule_matching=module_rule_matching;
}


void unregister_rule_matching()
{
	rule_matching=ip_cs_norule;
}



int init_module(void)
{

 	
	
	

		 printk("#############INSERT MATCHING MODIFIED\n");

	
    
	register_rule_matching();
	

	return 0;


}

void cleanup_module(void)
{
	unregister_rule_matching();
	/*rule_matching=ip_cs_null; */      
 printk("################REMOVED MATCHING111111111\n");
}

